%define threading  1
%define largefiles 1
%define suidperl   1

%define multilib_64_archs x86_64 s390x ppc64 sparc64

%define perlver 5.8.5
%define perlrel 57.el4
%define perlepoch 3

%{?!perl_debugging:    %define perl_debugging 0}
%if %{perl_debugging}
%define debug_package %{nil}
%endif

Provides: perl(:WITH_PERLIO)

%if %{threading}
%define thread_arch -thread-multi
Provides: perl(:WITH_ITHREADS)
Provides: perl(:WITH_THREADS)
%else
%define thread_arch %{nil}
Provides: perl(:WITHOUT_ITHREADS)
Provides: perl(:WITHOUT_THREADS)
%endif

%define perlmodcompat 5.8.4 5.8.3 5.8.2 5.8.1 5.8.0
Provides: perl(:MODULE_COMPAT_5.8.0)
Provides: perl(:MODULE_COMPAT_5.8.1)
Provides: perl(:MODULE_COMPAT_5.8.2)
Provides: perl(:MODULE_COMPAT_5.8.3)
Provides: perl(:MODULE_COMPAT_5.8.4)
Provides: perl(:MODULE_COMPAT_5.8.5)

%if %{largefiles}
Provides: perl(:WITH_LARGEFILES)
%else
Provides: perl(:WITHOUT_LARGEFILES)
%endif

Summary: The Perl programming language.
Name: perl
Version: %{perlver}
Release: %{perlrel}
Epoch: %{perlepoch}
License: Artistic or GPL
Group: Development/Languages
Url: http://www.perl.org/

Source0: perl-5.8.5.tar.gz
Source1: clean-manifest.pl
Source9: MANIFEST.suidperl
Source10: system-owned-directories
Source11: filter-depends.sh
Source12: perl-5.8.0-libnet.cfg
Source13: RHEL4.tar.gz
Source14: upload_post_text.txt

Patch5: perl-5.8.0-root.patch
Patch7: perl-5.6.0-buildroot.patch
Patch9: perl-5.7.3-syslog.patch
Patch12: perl-5.8.5-oldarch.patch
Patch13: perl-5.8.3-perlbug-tag.patch
Patch14: perl-5.8.5-dashI.patch

%define __perl_requires %{SOURCE11}

#Conflicts: perl-NDBM_File <= 1:1.75-34.99.6

Obsoletes: perl-Digest-MD5
Obsoletes: perl-MIME-Base64
Obsoletes: perl-libnet
Obsoletes: perl-Storable
Obsoletes: perl-CGI
Obsoletes: perl-CPAN
Obsoletes: perl-DB_File

# Configure doesn't listen well when we say no ndbm.  When it links in, it then conflicts with berkeley db.  oops.
Patch16: perl-5.8.0-nondbm.patch

# make sure we get the proper ldflags on libperl.so
Patch17: perl-5.8.0-sharedlinker.patch

# perl 5.8.0 likes to use man3ext for BOTH directories AND files.  not kosher.
# Patch18: perl-5.8.0-manext.patch

# lynx is depracated, use links instead
Patch19: perl-5.8.0-links.patch

# bugzilla 101767, make sure threads.so links directly to -lpthread
Patch22: perl-5.8.1-lpthread-link.patch

# bugzilla 118877
#Patch23: perl-5.8.3-findbin-selinux.patch
Patch23: perl-5.8.6-findbin-selinux.patch

# fix empty RPATH security issue
Patch24: perl-5.8.3-empty-rpath.patch

Patch26: perl-5.8.0-rmtree.patch
Patch27: perl-5.8.5-CAN-2005-0448.patch
Patch28: perl-5.8.5-CAN-2004-0976.patch
Patch29: perl-5.8.5-CVE-2004-0976-2.patch
Patch30: perl-5.8.5-CVE-2005-0155.patch
Patch31: perl-5.8.5-CVE-2008-1927.patch

# arch-specific patches
Patch100: perl-5.8.1-fpic.patch
Patch101: perl-5.8.0-libdir64.patch

Patch23337: perl-5.8.5+23337-environment.patch

Patch32002: perl-5.8.0-nptlhint.patch

Patch32003: perl-5.8.5-libresolv.patch

Patch170088: perl-h2ph-5.8.5-5.8.7.patch

Patch171111: perl-5.8.5-bz171111.patch

Patch172236: perl-5.8.5-bz172236.patch

Patch164772: perl-5.8.5-bz164772.patch

Patch172327: perl-5.8.5-bz172327_obz37056.patch

Patch136009: perl-5.8.5-MM_Unix-rpath-136009.patch

Patch174683: perl-5.8.5-CVE-2005-3962-bz174683.patch

Patch178343: perl-5.8.5-bz178343.patch

Patch185240: perl-5.8.5-bz185240.patch

Patch161305: perl-5.8.5-bz161305.patch

Patch191409: perl-5.8.5-bz191409-fix_h2ph_if_defined_expr.patch

Patch323571: perl-5.8.5-bz323571.patch
#
# module updatesd
# Patch202: perl-5.8.0-Safe2.09.patch

# Malformed UTF-8 character against latin1
Patch32:	perl-5.8.5-rt37950.patch
# buggy regexp in perl5/5.8.5
Patch33:	perl-5.8.5-bz203357.patch
# Perl 5.8.5 foreach on threads::shared array crashes perl
Patch34:	perl-5.8.5-rt32033.patch
# rhbz#427343  closures with threading
Patch35:	perl-5.8.5-rt31851.patch
# instmodsh wasn't working because of typo in script
Patch36:	perl-5.8.5-bz432880.patch
# CVE-2010-1168 CVE-2010-1447 = update to v2.27
Patch37:        perl-update-Safe.patch
# 743095 - perl: code injection vulnerability in Digest->new()
Patch38:        perl-5.8.8-Digest_vulnerability.patch
# CVE-2010-2761 CVE-2010-4410 based on security release from CGI-3.50
Patch39:    perl-5.8.8-CGI-CVE-2010-4410.patch

Buildroot: %{_tmppath}/%{name}-root
BuildRequires: , bash, gcc, binutils, make, gawk, grep, tcsh, gdbm-devel, db4-devel, dos2unix, man, groff
# required for perl headers:
BuildRequires: glibc-headers, glibc-kernheaders
BuildRequires: elfutils-devel, gdbm-devel, gpm-devel, libjpeg-devel
BuildRequires: libpng-devel, libtiff-devel, ncurses-devel, popt
BuildRequires: zlib-devel, e2fsprogs-devel, pam-devel, rpm-devel 

# By definition of 'do' (see 'man perlfunc') this package provides all
# versions of perl previous to it.
Provides: perl <= %{epoch}:%{version}

# These provides are needed by the perl pkg itself with auto-generated perl.req
Provides: perl(VMS::Filespec)
Provides: perl(VMS::Stdio)

Provides: perl(abbrev.pl)
Provides: perl(assert.pl)
Provides: perl(bigfloat.pl)
Provides: perl(bigint.pl)
Provides: perl(bigrat.pl)
Provides: perl(bytes_heavy.pl)
Provides: perl(cacheout.pl)
Provides: perl(complete.pl)
Provides: perl(ctime.pl)
Provides: perl(dotsh.pl)
Provides: perl(dumpvar.pl)
Provides: perl(exceptions.pl)
Provides: perl(fastcwd.pl)
Provides: perl(find.pl)
Provides: perl(finddepth.pl)
Provides: perl(flush.pl)
Provides: perl(ftp.pl)
Provides: perl(getcwd.pl)
Provides: perl(getopt.pl)
Provides: perl(getopts.pl)
Provides: perl(hostname.pl)
Provides: perl(importenv.pl)
Provides: perl(look.pl)
Provides: perl(newgetopt.pl)
Provides: perl(open2.pl)
Provides: perl(open3.pl)
Provides: perl(perl5db.pl)
Provides: perl(pwd.pl)
Provides: perl(shellwords.pl)
Provides: perl(stat.pl)
Provides: perl(syslog.pl)
Provides: perl(tainted.pl)
Provides: perl(termcap.pl)
Provides: perl(timelocal.pl)
Provides: perl(utf8_heavy.pl)
Provides: perl(validate.pl)

Provides: perl(Carp::Heavy)

# These modules appear to be missing or break assumptions made by the
# dependency analysis tools.  Typical problems include refering to
# CGI::Apache as Apache and having no package line in CPAN::Nox.pm. I
# hope that the perl people fix these to work with our dependency
# engine or give us better dependency tools.
#
# Provides: perl(Apache)
# Provides: perl(ExtUtils::MM_Mac)
# Provides: perl(ExtUtils::XSSymSet)
# Provides: perl(LWP::UserAgent)
# Provides: perl(URI::URL)

%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications are system
administration utilities and web programming.  A large proportion of
the CGI scripts on the web are written in Perl.  You need the perl
package installed on your system so that your system can handle Perl
scripts.

Install this package if you want to program in Perl or enable your
system to handle Perl scripts.

%if %{suidperl}
%package suidperl
Summary: suidperl, for use with setuid perl scripts
Group: Development/Languages
Requires: perl = %{perlepoch}:%{perlver}-%{perlrel}

%description suidperl
suidperl is a setuid binary copy of perl that allows for (hopefully)
more secure running of setuid perl scripts.
%endif

%prep
%setup -q -a 13 -n perl-5.8.5
%patch5 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

%patch17 -p1

%patch19 -p1
%patch23 -p1
%patch24 -p1

%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch31 -p1

%patch100 -p1

%ifarch %{multilib_64_archs}
%patch101 -p1
%endif

%patch23337 -p1 -b .23337-environment

%patch32002 -p1

%patch32003 -p1

%patch170088 -p1

%patch171111 -p1

%patch172236 -p1

%patch164772 -p1

%patch172327 -p1

%patch136009 -p1

%patch174683 -p1

%patch178343 -p1 

%patch185240 -p1 

%patch161305 -p1

%patch191409 -p1

%patch323571 -p1

%patch30 -p1

%patch32 -p1

%patch33 -p1

%patch34 -p1

%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1

# apply binary sources
# CGI
cp %{SOURCE14} ./lib/CGI/t/

find . -name \*.orig -exec rm -fv {} \;

%build

echo "RPM Build arch: %{_arch}"

[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# yes; don't use %_libdir so that noarch packages from other OSs
# arches work correctly :\ the Configure lines below hardcode lib for
# similar reasons.

%ifarch %{multilib_64_archs}
	mkdir -p $RPM_BUILD_ROOT/usr/lib/perl5/%{perlver}
	mkdir -p $RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{perlver}
	mkdir -p $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perlver}
%endif

sh Configure -des -Doptimize="$RPM_OPT_FLAGS" \
	-Dversion=5.8.5 \
	-Dmyhostname=localhost \
	-Dperladmin=root@localhost \
	-Dcc='%{__cc}' \
        -Dcf_by='Red Hat, Inc.' \
	-Dinstallprefix=$RPM_BUILD_ROOT%{_prefix} \
	-Dprefix=%{_prefix} \
%ifarch %{multilib_64_archs}
	-Dlibpth="/usr/local/lib64 /lib64 /usr/lib64" \
	-Dprivlib="/usr/lib/perl5/%{version}" \
	-Dsitelib="/usr/lib/perl5/site_perl/%{version}" \
	-Dvendorlib="/usr/lib/perl5/vendor_perl/%{version}" \
	-Darchlib="%{_libdir}/perl5/%{perlver}/%{_arch}-%{_os}%{thread_arch}" \
	-Dsitearch="%{_libdir}/perl5/site_perl/%{perlver}/%{_arch}-%{_os}%{thread_arch}" \
	-Dvendorarch="%{_libdir}/perl5/vendor_perl/%{perlver}/%{_arch}-%{_os}%{thread_arch}" \
%endif
	-Darchname=%{_arch}-%{_os}%{thread_arch} \
%ifarch sparc
	-Ud_longdbl \
%endif
	-Dvendorprefix=%{_prefix} \
	-Dsiteprefix=%{_prefix} \
	-Duseshrplib \
%if %threading
	-Dusethreads \
        -Duseithreads \
%else
	-Uusethreads \
        -Uuseithreads \
%endif
%if %largefiles
        -Duselargefiles \
%else
        -Uuselargefiles \
%endif
	-Dd_dosuid \
	-Dd_semctl_semun \
	-Di_db \
	-Ui_ndbm \
	-Di_gdbm \
	-Di_shadow \
	-Di_syslog \
	-Dman3ext=3pm \
	-Duseperlio \
	-Dinstallusrbinperl \
	-Ubincompat5005 \
	-Uversiononly \
	-Dpager='/usr/bin/less -isr' \
	-Dinc_version_list='%{perlmodcompat}' 

make

# remove network test
#rm -rf lib/Net/t/hostname.t

##make test

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

make install -f Makefile

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
install -m 755 utils/pl2pm ${RPM_BUILD_ROOT}%{_bindir}/pl2pm

# build MANIFEST.all

%define new_perl_lib  $RPM_BUILD_ROOT%{_libdir}/perl5/%{perlver}:$RPM_BUILD_ROOT/usr/lib/perl5/%{perlver}
%define comp_perl_lib $RPM_BUILD_ROOT/usr/lib/perl5/%{perlver}:$RPM_BUILD_ROOT/usr/lib/perl5/%{perlver}
%define new_arch_lib  $RPM_BUILD_ROOT%{_libdir}/perl5/%{perlver}/%{_arch}-%{_os}%{thread_arch}
%define comp_arch_lib $RPM_BUILD_ROOT/usr/lib/perl5/%{perlver}/%{_arch}-%{_os}%{thread_arch}

%define new_perl_flags LD_PRELOAD=/%{new_arch_lib}/CORE/libperl.so LD_LIBRARY_PATH=%{new_arch_lib}/CORE PERL5LIB=%{new_perl_lib}:%{comp_perl_lib}
%define new_perl %{new_perl_flags} $RPM_BUILD_ROOT/%{_bindir}/perl

# Generate perl headers:
# (let's err on the side of excess rather than deficiency :-)
#

%define new_h2ph %{new_perl} $RPM_BUILD_ROOT/%{_bindir}/h2ph -Q -a -d ${RPM_BUILD_ROOT}%{_libdir}/perl5/%{perlver}/%{_arch}-%{_os}%{thread_arch}
%define redirect_out "'>/dev/null 2>&1 || :;'"
%define h2ph_cmd "'LD_LIBRARY_PATH='%{new_arch_lib}/CORE' PERL5LIB='%{new_perl_lib}' '$RPM_BUILD_ROOT/%{_bindir}/perl' '$RPM_BUILD_ROOT/%{_bindir}/h2ph' -Q -a -d '${RPM_BUILD_ROOT}%{_libdir}/perl5/%{perlver}/%{_arch}-%{_os}%{thread_arch}' '%{redirect_out}"

( cat ./RHEL4/%{_arch} ) |
( h2ph_cmd="%{h2ph_cmd}";
  %{new_perl} -e '$cmd=$ENV{h2ph_cmd};
          $clen=length($cmd); $len=$clen; $cmd="";
	          while(<>)
		  { $_=~s/\n$/ /; $_=~s|^'%{_includedir}/'||; $len += length($_);
	    if( $len > 131072 ){ print $cmd,"\n"; $cmd=""; $len=$clen; };
		    $cmd .= $_;
		  };
		  print $cmd,"\n";'
) |		  
( cd %{_includedir};
  while read f;
  do
  %{new_h2ph} $f  >/dev/null 2>&1 || :;
  done
);


%{new_perl} -p -i -e "s|$RPM_BUILD_ROOT||g;" %{new_arch_lib}/Config.pm

mkdir -pm 755 $RPM_BUILD_ROOT%{_libdir}/perl5/site_perl/%{perlver}/%{_arch}-%{_os}%{thread_arch}/auto
mkdir -pm 755 $RPM_BUILD_ROOT%{_libdir}/perl5/vendor_perl/%{perlver}/%{_arch}-%{_os}%{thread_arch}/auto

%ifarch %{multilib_64_archs}
mkdir -pm 755 $RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{perlver}
mkdir -pm 755 $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perlver}
%endif

install -m 0644 %{SOURCE12} $RPM_BUILD_ROOT%{_prefix}/lib/perl5/%{perlver}/Net/libnet.cfg

# Remove conflicts with separate perl-Filter package (ONLY!):
rm -rf $RPM_BUILD_ROOT{{%{_libdir},/usr/lib}/perl5/%{perlver}/{,%{_arch}-%{_os}%{thread_arch}{,/auto}}/Filter,%{_mandir}/man3/Filter::*} || :;
# Remove conflicts with separate perl-Time-HiRes package (ONLY!):
rm -rf $RPM_BUILD_ROOT{{%{_libdir},/usr/lib}/perl5/%{perlver}/%{_arch}-%{_os}%{thread_arch}{,/auto}/Time,%{_mandir}/man3/Time::HiRes*} || :;
# Remove obsolete NDBM modules and empty .bs files:
find $RPM_BUILD_ROOT -name '*NDBM*' -o -type f -name '*.bs' -empty | xargs rm -f

find $RPM_BUILD_ROOT \( -type f -or -type l \) -and \
	-not -path $RPM_BUILD_ROOT%{_prefix}/lib/perl5/%{perlver}/Net/libnet.cfg > MANIFEST.all
find $RPM_BUILD_ROOT -type d -printf "%%%%dir %p\n" >> MANIFEST.all

%{new_perl} -i -p -e "s|$RPM_BUILD_ROOT||g;" MANIFEST.all

# add .gz to all the entries in the man directories.  necessary since
# brp-compress takes place after the manifest is built but the %files
# section must match what it ends up renaming files into
%{new_perl} -i -p -e 's((^/usr/share/man/.*))($1.gz)g' MANIFEST.all

cp MANIFEST.all /tmp

for i in  %{SOURCE10} 
do
  %{new_perl} %{SOURCE1} %{_arch} $i MANIFEST.all MANIFEST.all.tmp %{_libdir} %{thread_arch}
  mv MANIFEST.all.tmp MANIFEST.all
done

%if %{suidperl}
  %{new_perl} %{SOURCE1} %{_arch} %{SOURCE9} MANIFEST.all MANIFEST.all.tmp %{_libdir} %{thread_arch}
  mv MANIFEST.all.tmp MANIFEST.all
%endif

# fix the rest of the stuff
find $RPM_BUILD_ROOT%{_libdir}/perl* \
  -name .packlist -o -name perllocal.pod -o -name config.h | \
    %{new_perl_flags} xargs $RPM_BUILD_ROOT/%{_bindir}/perl -I lib/ -i -p -e "s|$RPM_BUILD_ROOT||g;" MANIFEST.all

%if %{perl_debugging}
#  disable debuginfo generation (for testing only!) 
   /usr/lib/rpm/brp-compress
   exit 0
%endif


%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files -f MANIFEST.all
%defattr(-,root,root,-)
%config(noreplace) %{_prefix}/lib/perl5/%{perlver}/Net/libnet.cfg

%if %{suidperl}
%files -f %{SOURCE9} suidperl
%defattr(-,root,root,-)
%endif

%changelog
* Fri Nov 11 2011  Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-57.el4
- CVE-2010-2761 CVE-2010-4410 patch based on security release CGI-3.50
- Related: rhbz#743627

* Thu Oct  6 2011  Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-56.el4
- CVE-2010-2761 CVE-2010-4410 perl: CGI module multiple issues fixed by 
  update to CGI 3.54
- Resolves: rhbz#743627

* Tue Oct  4 2011 Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-54.el4
- 743095 - perl: code injection vulnerability in Digest->new()
- Resolves: rhbz#743096

* Mon May 17 2010 Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-52.el4
- build system contains new rpm, which can't create list of header files
 anymore (failure of rpm -ql). Arch specific files contain list of all
 header files for RHEL-4  or mentioned packages.
- Related: rhbz#591160

* Wed May 12 2010 Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-50.el4
- CVE-2010-1168 perl Safe: Intended restriction bypass via object references
- CVE-2010-1447 Safe 2.26 and earlier: Intended restriction bypass via Perl 
  object references in code executed outside safe compartment
  Both solved by update to the v2.27.
- Related: rhbz#591160

* Thu Mar  5 2009 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-49.el4
- Fix perl-5.8.5-oldarch.patch to handle 64bit archs correctly.
- Resolves: rhbz#456566
- Drop perl-5.8.0-rpath-make.patch--it mis-applied with fuzz 2 and had
  no effect.

* Thu Feb 19 2009 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-48.el4
- do not use dist-tag

* Wed Feb 18 2009 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-47.el4
- use dist-tag

* Thu Dec 11 2008 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-46.RHEL4
- really remove *NDBM* files, even when find does not have -delete

* Thu Dec 11 2008 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-45.RHEL4
- various changelog fixes

* Thu Dec 11 2008 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-42.RHEL4
- Fix -Darchname on the Configure line.
- Make sure that perl.rpm does not contain compatibility version directories.
  Replace perl-*-fullinc.patch and perl-*-incpush.patch by
  perl-5.8.5-oldarch.patch so that nonexistent directories dont get to @INC.
- Resolves: rhbz#456566

* Fri Dec  5 2008 Stepan Kasal <skasal@redhat.com> - 3:5.8.5-41.RHEL4
- this package should not own /usr/lib64, list it in system-owned-directories
- Install libnet.cfg to $privlib/Net, where is is searched for, not to
  $archlib/Net, and mark it %%config(noreplace)
- Resolves: rhbz#227655

* Fri Nov 28 2008 Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-40.RHEL4
- Resolves: rhbz#203357, rhbz#427343, rhbz#427523, rhbz#432880, rhbz#467164

* Tue Jun 24 2008 Marcela Maslanova <mmaslano@redhat.com> - 3:5.8.5-39.RHEL4
- CVE-2008-1927 perl: double free on regular expressions with utf8 characters
- Resolves: rhbz#449322

* Mon Oct 22 2007 Robin Norwood <rnorwood@redhat.com> - 3:5.8.5-38.RHEL4
- Resolves: bug#323801
- fix previous patch

* Wed Oct 10 2007 Robin Norwood <rnorwood@redhat.com> - 3:5.8.5-37.RHEL4
- Resolves: bug#323801
- fix regular expression UTF parsing errors

* Mon Jul 24 2006 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-36.RHEL4
- fix bug 199916 / CVE-2005-0155 - disable PERLIO_DEBUG under setuid perl

* Thu May 11 2006 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-34.RHEL4
- fix errata testing issue - bug 191409, upstream perlbug 39130:
  o prevent h2ph emitting incorrect code for '#if defined A || defined B'

* Wed May 10 2006 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-30.RHEL4
- fix errata testing issues:
  o bug 161305 localtime_r_needs_tzset incorrectly not set on 64-bit arches
  o generate perl headers correctly to avoid missing / unresolved headers

* Wed Apr 05 2006 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-28.RHEL4
- fix bug 161305: call tzset() before localtime_r

* Mon Mar 03 2006 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-26.RHEL4
- fix bug 185240: restore default minimum ioctl 3rd arg length of 256
- fix bug 178343: include cpp built-in macros in $Config{cppsymbols}
- fix bug 84671:  cleanup NDBM removal; restore DBM_Filter* .

* Fri Dec 16 2005 Jason Vas Dias <jvdias@redhat.com> - 2:5.8.5-24.RHEL4
- fix to fix for CVE-2004-0976 / bz136325: perl5db.pl typo '/tmp' -> '"/tmp"'!

* Mon Dec 12 2005 Jason Vas Dias <jvdias@redhat.com> - 2:5.8.5-22.RHEL4
- Further enhancements to sprintf integer overflow patch
  (Upstream patches 26322 26331 and 26333 for CVE-2005-3962 / bz174717 )
- Fix CVE-2004-0976 / bz136325: fix issues with solardesigner's patch
  to perldbtty.pl and c2ph.PL, pointed out by Pekka Savola and David Eisenstein

* Fri Dec 09 2005 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-20.RHEL4
- Apply upstream patches 26283 and 26284 : complete, revised fixes
  for bug 174683 / CVE-2005-3962 and CVE-2005-3912 and 
  "Sys::Syslog security vulnerabilities" issues.
- Fix bug 136009 / MakeMaker LD_RUN_PATH issue: 
  restore previous default Red Hat behavior of removing the MakeMaker
  generated LD_RUN_PATH setting from the link command .
  Document this removal, as it contravenes upstream default behavior, and 
  provide a USE_MM_LD_RUN_PATH MakeMaker member to enable use of the 
  MakeMaker generated LD_RUN_PATH .

* Thu Dec 01 2005 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-18.RHEL4
- fix bug 174683 / CVE-2005-3962: sprintf integer overflow vulnerability
  backport upstream patch #26240

* Wed Nov 09 2005 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-17.RHEL4
- fix bug 136009: restore MakeMaker support for LD_RUN_PATH, 
  while removing empty LD_RUN_PATH

* Tue Nov 08 2005 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-17.RHEL4
- fix CAN-2004-0976: insecure use of temporary files

* Wed Nov  2 2005 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-17.RHEL4
- fix bug 164772: panic (crash) on invalid UTF-8 in Encode.xs
- fix bug 172327 / upstream bug 37056: backport upstream patch 25084:
  prevent realloc recursion on nss get* ERANGE errno

* Tue Nov  1 2005 Jason Vas Dias <jvdias@redhat.com> - 3:5.8.5-17.RHEL4
- fix bug 170088: broken h2ph fixed with h2ph from 5.8.7
- fix bug 171111 / upstream bug 37535: IOCPARM_LEN should be _IOC_SIZE
- fix bug 172236: make h2ph pick up gcc built-in include directory

* Tue Aug  2 2005 Petr Rockai <prockai@redhat.com> - 3:5.8.5-16.RHEL4
- update filter-depends.sh to get rid of FCGI requires

* Wed Jul 27 2005 Petr Rockai <prockai@redhat.com> - 3:5.8.5-15.RHEL4
- remove incorrect Provides on FCGI and Mac::File, cf. BR148848

* Mon Jul 18 2005 Petr Rockai <prockai@redhat.com> - 3:5.8.5-14.RHEL4
- remove the suidperl .1 release tag munging (from FC-3)
- fix for BR127023 using the patch from the report (by Jose Pedro Oliveira)
  (perl fails "lib/FindBin" test (breaks MRTG), from FC-3)
- apply fix for CAN-2004-0452 (#156128, #146774) - from FC-3,
  required by following
- fix for CAN-2005-0448 - patch by Brendan O'Dea from Debian, backported
  by myself (from FC-3)

* Tue May 31 2005 Petr Rockai <prockai@redhat.com> - 3:5.8.5-13.RHEL4
- Fix for BR159021, segfault on environment changes, upstream patch
  23337. Thanks to bert.barbe <at> oracle.com for testcase and diagnostics.

* Wed Dec  1 2004 Chip Turner <cturner@redhat.com> 3:5.8.5-9
- bugzilla: 140563, nptl doesn't act like linuxthreads; threads have no PIDs

* Tue Oct 12 2004 Jose Pedro Oliveira <jpo@di.uminho.pt>
- Corrected the license information (missing GPL).
- Added the URL tag.
- Removed empty .bs files.
- Eliminated several strip generated messages (bug 127025).
- Corrected problems mentioned in bug 120772
  (updated Ville Skytt* Tue Oct 12 2004 Chip Turner <cturner@redhat.com> 3:5.8.5-7

* Tue Oct 12 2004 Chip Turner <cturner@redhat.com>
- bugzilla: 135303, add more missing 5.8.4 paths

* Mon Oct 11 2004 Tim Waugh <twaugh@redhat.com>
- Build requires groff (bug #135101).

* Tue Oct  5 2004 Chip Turner <cturner@redhat.com> 3:5.8.5-7
- update perlbug patch to strip build date as well

* Mon Aug 23 2004 Chip Turner <cturner@redhat.com> 3:5.8.5-2
- fix conflicting file when building on x86_64 and i386

* Sat Jul 24 2004 Chip Turner <cturner@redhat.com> 3:5.8.5-1
- Add Provides: Carp::Heavy to fix new dep error (bz 128507)

* Thu Jul 22 2004 Chip Turner <cturner@redhat.com> 3:5.8.5-1
- update to 5.8.5

* Mon Jun 28 2004 Chip Turner <cturner@redhat.com> 3:5.8.4-1
- update to 5.8.4, remove patch 8

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Apr 15 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-18
- add patch to fix empty RPATH issue on perl module compile

* Sat Apr 03 2004 Colin Walters <walters@redhat.com> 3:5.8.3-17
- Apply patch to fix FindBin module when access to cwd is disallowed,
  should solve the MRTG/SELinux cron spam issue

* Tue Mar 23 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-14
- make sure multilib boxes also own the entries in @INC that are in /usr/lib, not just %_libdir

* Tue Mar  9 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-%{perlrel}.1
- fix i386-specifics in %%install to arch generic

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Feb 25 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-10
- add perl(:MODULE_COMPAT_*) provides; make sure all of @INC is owned by perl package

* Thu Feb 19 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-8
- rebuild

* Thu Feb 19 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-7.9.rhl9
- rebuild

 patch for perl 5.8.4).

* Thu Feb 19 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-7.10.fc1
- rebuild

* Sun Feb 15 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-6
- fix very broken @INC calculations with slightly less broken @INC
  calculations (not perfectly handled but the result is correct)
- fix broken -Dsitearch declaration

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jan 28 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-5
- update incpush patch to better handle multilib

* Fri Jan 23 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-2
- add a dependency filter on perl(Tie::RangeHash)

* Thu Jan 22 2004 Chip Turner <cturner@redhat.com> 3:5.8.3-7
- upgrade to 5.8.3

* Mon Dec 15 2003 Chip Turner <cturner@redhat.com> 3:5.8.2-7
- fix @INC so that all dirs go into it, not just those that exist at buildtime in the build system

* Sat Dec 13 2003 Jeff Johnson <jbj@jbj.org> 3:5.8.2-4
- rebuild against db-4.2.52.

* Sun Dec  7 2003 Ville Skyttä <ville.skytta at iki.fi> - 3:5.8.2-3
- Own site and vendor auto directories (#73970).

* Wed Dec  3 2003 Chip Turner <cturner@redhat.com> 3:5.8.2-2
- upgrade to 5.8.2

* Fri Oct 31 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-92
- remove Vendor and Distribution macros from specfile (#108567)

* Wed Oct 15 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-92
- add srand on fork patch from upstream, as well as test case

* Mon Oct 13 2003 Jeff Johnson <jbj@jbj.org> 3:5.8.1-91.1
- rebuild against db-4.2.42.

* Thu Sep 25 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-91
- perl 5.8.1 final

* Mon Sep 22 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-90.rc5.3
- ensure inc_version_list is always set properly

* Mon Sep 22 2003 Chip Turner <cturner@redhat.com>
- update to RC5

* Wed Aug 20 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-90.rc4.2
- rebuild

* Wed Aug  6 2003 Chip Turner <cturner@redhat.com>
- bugzilla 101767, make sure threads.so links directly to -lpthread

* Fri Aug  1 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-90.rc2.1
- RC4
- remove perl-5.8.0-fhs.patch since it is integrated now
- remove perl-5.8.0-Safe2.09.patch, unnecessary now

* Fri Jul 11 2003 Chip Turner <cturner@redhat.com> 3:5.8.1-90.rc2.1
- rc2 snapshot

* Thu Jul 10 2003 Chip Turner <cturner@redhat.com> 3:5.8.0-90.rc1
- upgrade to 5.8.1 RC1

* Mon Jul  7 2003 Chip Turner <cturner@redhat.com> 3:5.8.0-89.pre%{PRELEVEL}.0
- integrate another pre-5.8.1 release

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon May 19 2003 Chip Turner <cturner@redhat.com> 3:5.8.0-89.pre%{PRELEVEL}.0
- bump epoch since we went from perl 5.8.1-pre to 5.8.0-pre (ie,
  changed what version perl thought of itself as)

* Mon May  5 2003 Chip Turner <cturner@redhat.com> 2:5.8.1-0.pre%{PRELEVEL}.3
- rebuild

* Thu May  1 2003 Chip Turner <cturner@redhat.com>
- bump for rebuilg

* Sun Apr 27 2003 Chip Turner <cturner@redhat.com> 2:5.8.1-0.pre%{PRELEVEL}.1
- fix the fix for RPM_BUILD_ROOT substitution

* Tue Apr 22 2003 Chip Turner <cturner@redhat.com> 2:5.8.1-0.pre%{PRELEVEL}.3
- fix Config.pm; lost when h2ph changes made

* Thu Apr 17 2003 Chip Turner <cturner@redhat.com> 2:5.8.1-0.pre%{PRELEVEL}
- move to latest snapshot, 19261

* Tue Feb 18 2003 Chip Turner <cturner@redhat.com>
- fix MANIFEST.DB_File handling for #83410; problem was unsubstituted
  %{_libdir} that crept in with multilib

* Tue Feb 18 2003 Bill Nottingham <notting@redhat.com> 5.8.0-87
- clean up backup files from patches (#82838)

* Wed Feb 05 2003 Elliot Lee <sopwith@redhat.com> 5.8.0-86
- Fix up multilib handling to use multilib_64_archs macro, add ppc64.
- Patch100 probably makes sense on all archs, and ifarch'd patches are Bad(tm).

* Mon Jan 27 2003 Chip Turner <cturner@redhat.com>
- version the Obsoleted on perl-NDBM_File so users can install newer
- change the Obsoletes on NDBM_File to a Conflicts
  ones than what shipped with 7.3, yet still keep anaconda happy

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Jan  9 2003 Chip Turner <cturner@redhat.com>
- rebuild

* Sat Jan  4 2003 Jeff Johnson <jbj@redhat.com> 5.8.0-82
- use internal dep generator.

* Thu Jan  2 2003 Chip Turner <cturner@redhat.com>
- fix issue with -Dpager in Pod::Perldoc.pm to properly respect setting once more

* Tue Dec 31 2002 Chip Turner <cturner@redhat.com>
- add rpath fix to prevent building perl from using installed system perl
- massive re-integration of upstream patches to come to common basis (head of perl-maint branch)

* Mon Dec 16 2002 Chip Turner <cturner@redhat.com>
- rebuild

* Sun Dec 15 2002 Chip Turner <cturner@redhat.com>
- add numerous upstream patches to fix utf8/perlio issues
- upgrade Storable, Safe, and Encoding to latest CPAN versions

* Thu Nov  7 2002 Chip Turner <cturner@redhat.com>
- multilib support when building noarch perl modules
- integrate upstream bugfix patches

* Tue Sep 10 2002 Chip Turner <cturner@redhat.com>
- integrate patch for /usr/lib64 instead of /usr/lib from Than Ngo

* Mon Sep  9 2002 Chip Turner <cturner@redhat.com>
- integrate s390/s390x patch from Florian La Roche

* Sun Sep  1 2002 Chip Turner <cturner@redhat.com>
- fix pager issues; default to /usr/bin/less -isr
- more work on pager bug (72125)

* Thu Aug 29 2002 Chip Turner <cturner@redhat.com>
- add a few new directories to h2ph to produce better .ph files

* Thu Aug 15 2002 Chip Turner <cturner@redhat.com>
- change from lynx to links in CPAN.pm

* Tue Aug  6 2002 Chip Turner <cturner@redhat.com>
- automated release bump and build
- remove Filter packages and use CPAN ones

* Fri Jul 19 2002 Chip Turner <cturner@redhat.com>
- move to final perl 5.8.0, huzzah!

* Tue Jul 16 2002 Chip Turner <cturner@redhat.com>
- update CPAN, CGI, and DB_File versions; obsolete perl-libnet
- libnet.cfg supplied, default to passive ftp in all cases

* Tue Jun 18 2002 Chip Turner <cturner@redhat.com>
- add patch to ensire libperl.so is linked properly

* Mon May 20 2002 Nalin Dahyabhai <nalin@redhat.com>
- always build with -fPIC

* Thu May  9 2002 Jeff Johnson <jbj@redhat.com>
- rebuild in rawhide

* Sun Mar 31 2002 Chip Turner <cturner@redhat.com>
- split suidperl back out (bug #62215)

* Tue Mar 26 2002 Chip Turner <cturner@redhat.com>
- restructuring of some directories, alteration of @INC

* Thu Dec 20 2001 Chip Turner <cturner@redhat.com>
- remove ndbm completely

* Sun Dec 16 2001 Chip Turner <cturner@redhat.com>
- make rpmlint happy, split out NDBM_File, clean up other spots
- stopped doing grep -v etc in favor of custom script

* Wed Dec 12 2001 Chip Turner <cturner@redhat.com>
- cleaning up of ia64 issues, as well as compatibility with gcc 3.1
  and glibc 2.2.4

* Mon Sep 24 2001 Chip Turner <cturner@redhat.com>
- changing building of extra modules out of the core perl rpm

* Mon Sep 17 2001 Chip Turner <cturner@redhat.com>
- upgrade to 5.6.1, added old INC dirs to maintain compat

* Fri Mar 23 2001 Preston Brown <pbrown@redhat.com>
- bzip2 source, save some space.

* Thu Dec  7 2000 Crutcher Dunnavant <crutcher@redhat.com>
- initial rebuild for 7.1

* Tue Sep 12 2000 Bill Nottingham <notting@redhat.com>
- fix dependencies on ia64/sparc64

* Mon Aug  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- replace the deprecated MD5 with Digest::MD5 (has to be here for cleanfeed)
- obsolete: perl-Digest-MD5
- use syslog instead of mail to report possible attempts to break into suidperl
- force syslog on at build-time

* Mon Jul 31 2000 Nalin Dahyabhai <nalin@redhat.com>
- add Owen's fix for #14779/#14863
- specify cc=%{__cc}; continue to let cpp sort itself out
- switch shadow support on (#8646)
- release 7

* Tue Jul 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- strip buildroot from perl pods (#14040)
- release 6

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild (release 5)

* Wed Jun 21 2000 Preston Brown <pbrown@redhat.com>
- don't require tcsh to install, only to build
- release 4

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild against new db3 package
- release 3

* Sat Jun 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable 64-bit file support
- change name of package that Perl expects gcc to be in from "egcs" to "gcc"
- move man pages to /usr/share via hints/linux.sh and MM_Unix.pm
- fix problems prefixifying with empty prefixes
- disable long doubles on sparc (they're the same as doubles anyway)
- add an Epoch to make sure we can upgrade from perl-5.00503
- release 2

* Thu Mar 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.6.0

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix description

* Fri Jan 14 2000 Jeff Johnson <jbj@redhat.com>
- add provides for perl modules (from kestes@staff.mail.com).

* Mon Oct 04 1999 Cristian Gafton <gafton@redhat.com>
- fix the %%install so that the MD5 module gets actually installed correctly

* Mon Aug 30 1999 Cristian Gafton <gafton@redhat.com>
- make sure the package builds even when we don't have perl installed on the
  system

* Fri Aug 06 1999 Cristian Gafton <gafton@redhat.com>
- merged with perl-MD5
- get rid of the annoying $RPM_BUILD_ROOT paths in the installed tree

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- do not link anymore against the system db library (and make each module
  link against it separately, so that we can have Berkeley db1 and db2 mixed
  up)

* Wed Jun 16 1999 Cristian Gafton <gafton@redhat.com>
- use wildcards for files in /usr/bin and /usr/man

* Tue Apr 06 1999 Cristian Gafton <gafton@redhat.com>
- version 5.00503
- make the default man3 install dir be release independent
- try to link against db1 to preserve compatibility with older databases;
  abandoned idea because perl is too broken to allow such an easy change
  (hardcoded names *everywhere* !!!)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- guilty of the inlined Makefile in the spec file
- adapted for the arm build

* Wed Sep 09 1998 Preston Brown <pbrown@redhat.com>
- added newer CGI.pm to the build
- changed the version naming scheme around to work with RPM

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- attempt to generate *.ph files reproducibly

* Mon Jun 15 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.004_04-m4 (pre-5.005 maintenance release)

* Tue Jun 12 1998 Christopher McCrory <chrismcc@netus.com
- need stdarg.h from gcc shadow to fix "use Sys::Syslog" (problem #635)

* Fri May 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to correct the .ph constructs unless defined (foo) to read
  unless(defined(foo))

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Mar 10 1998 Cristian Gafton <gafton@redhat.com>
- fixed strftime problem

* Sun Mar 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to fix a security race
- do not use setres[ug]id - those are not implemented on 2.0.3x kernels

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_04 - 5.004_01 had some nasty memory leaks.
- fixed the spec file to be version-independent

* Fri Dec 05 1997 Erik Troan <ewt@redhat.com>
- Config.pm wasn't right do to the builtrooting

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- fixed arch-specfic part of spec file

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- updated to perl 5.004_01
- users a build root

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- Incorporated security patch from Chip Salzenberg <salzench@nielsenmedia.com>

* Fri Feb 07 1997 Erik Troan <ewt@redhat.com>
- Use -Darchname=i386-linux 
- Require csh (for glob)
- Use RPM_ARCH during configuration and installation for arch independence
